clc;
clear all;
close all;
filenames = {'Q08.csv', 'Q09.csv', 'Q10.csv', 'Q11.csv', 'Q12.csv'};
numFiles = length(filenames);
tables = cell(numFiles, 1);
for i = 1:numFiles
    tables{i} = readtable(filenames{i});
    tables{i}.ForceTotalRadial = sqrt(tables{i}.ForceTotalX.^2 + tables{i}.ForceTotalY.^2);
end
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceTotalRadial_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceTotalRadial;
end
writetable(mergedTable, 'Combined_ForceTotalRadial.csv');
combinedTable = readtable('Combined_ForceTotalRadial.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceTotalRadial');
    grid on;
end
sgtitle('ForceTotalRadial vs. FlowTime for Each File');
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceTotalZ_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceTotalZ;
end
writetable(mergedTable, 'Combined_ForceTotalZ.csv');
combinedTable = readtable('Combined_ForceTotalZ.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceTotalZ');
    grid on;
end
sgtitle('ForceTotalZ vs. FlowTime for Each File');
FFT_plot_and_export('Combined_ForceTotalRadial.csv', 'Combined_ForceTotalRadial')
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceTotalX_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceTotalX;
end
writetable(mergedTable, 'Combined_ForceTotalX.csv');
combinedTable = readtable('Combined_ForceTotalX.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceTotalX');
    grid on;
end
sgtitle('ForceTotalX vs. FlowTime for Each File');
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceTotalY_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceTotalY;
end
writetable(mergedTable, 'Combined_ForceTotalY.csv');
combinedTable = readtable('Combined_ForceTotalY.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceTotalY');
    grid on;
end
sgtitle('ForceTotalY vs. FlowTime for Each File');
for i = 1:numFiles
    tables{i}.AngleYX=rad2deg(atan2(tables{i}.ForceTotalY,tables{i}.ForceTotalX));
end
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['AngleYX_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.AngleYX;
end
writetable(mergedTable, 'Combined_AngleYX.csv');
combinedTable = readtable('Combined_AngleYX.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('AngleYX');
    grid on;
end
sgtitle('AngleYX vs. FlowTime for Each File');
for i = 1:numFiles
    tables{i}.ForceAllBladesX =tables{i}.ForceBlade1PsX+tables{i}.ForceBlade1SsX...
   +tables{i}.ForceBlade2PsX+tables{i}.ForceBlade2SsX...
   +tables{i}.ForceBlade3PsX+tables{i}.ForceBlade3SsX...
   +tables{i}.ForceBlade4PsX+tables{i}.ForceBlade4SsX...
   +tables{i}.ForceBlade5PsX+tables{i}.ForceBlade5SsX...
   +tables{i}.ForceBlade6PsX+tables{i}.ForceBlade6SsX;
   tables{i}.ForceAllBladesXRatio=tables{i}.ForceAllBladesX./tables{i}.ForceTotalX;
end
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceAllBladesX_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceAllBladesX;
end
writetable(mergedTable, 'Combined_ForceAllBladesX.csv');
combinedTable = readtable('Combined_ForceAllBladesX.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceAllBladesX');
    grid on;
end
sgtitle('ForceAllBladesX vs. FlowTime for Each File');
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceAllBladesXRatio_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceAllBladesXRatio;
end
writetable(mergedTable, 'Combined_ForceAllBladesXRatio.csv');
combinedTable = readtable('Combined_ForceAllBladesXRatio.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceAllBladesXRatio');
    grid on;
end
sgtitle('ForceAllBladesXRatio vs. FlowTime for Each File');
for i = 1:numFiles
    tables{i}.ForceAllBladesY =tables{i}.ForceBlade1PsY+tables{i}.ForceBlade1SsY...
   +tables{i}.ForceBlade2PsY+tables{i}.ForceBlade2SsY...
   +tables{i}.ForceBlade3PsY+tables{i}.ForceBlade3SsY...
   +tables{i}.ForceBlade4PsY+tables{i}.ForceBlade4SsY...
   +tables{i}.ForceBlade5PsY+tables{i}.ForceBlade5SsY...
   +tables{i}.ForceBlade6PsY+tables{i}.ForceBlade6SsY;
   tables{i}.ForceAllBladesYRatio=tables{i}.ForceAllBladesY./tables{i}.ForceTotalY;
end
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceAllBladesY_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceAllBladesY;
end
writetable(mergedTable, 'Combined_ForceAllBladesY.csv');
combinedTable = readtable('Combined_ForceAllBladesY.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceAllBladesY');
    grid on;
end
sgtitle('ForceAllBladesY vs. FlowTime for Each File');
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceAllBladesYRatio_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceAllBladesYRatio;
end
writetable(mergedTable, 'Combined_ForceAllBladesYRatio.csv');
combinedTable = readtable('Combined_ForceAllBladesYRatio.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceAllBladesYRatio');
    grid on;
end
sgtitle('ForceAllBladesYRatio vs. FlowTime for Each File');
for i = 1:numFiles
    tables{i}.ForceAllBlades =sqrt(tables{i}.ForceAllBladesX.^2+tables{i}.ForceAllBladesY.^2);
	tables{i}.ForceAllBladesRatio =tables{i}.ForceAllBlades./tables{i}.ForceTotalRadial;
end
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceAllBlades_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceAllBlades;
end
writetable(mergedTable, 'Combined_ForceAllBlades.csv');
combinedTable = readtable('Combined_ForceAllBlades.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceAllBlades');
    grid on;
end
sgtitle('ForceAllBlades vs. FlowTime for Each File');
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['ForceAllBladesRatio_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.ForceAllBladesRatio;
end
writetable(mergedTable, 'Combined_ForceAllBladesRatio.csv');
combinedTable = readtable('Combined_ForceAllBladesRatio.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('ForceAllBladesRatio');
    grid on;
end
sgtitle('ForceAllBladesRatio vs. FlowTime for Each File');
for i = 1:numFiles
    tables{i}.AngleYXBlades=rad2deg(atan2(tables{i}.ForceAllBladesY,tables{i}.ForceAllBladesX));
end
mergedTable = tables{1}(:, {'FlowTime'});
for i = 1:numFiles
    columnName = ['AngleYXBlades_', regexp(filenames{i}, '\d+', 'match', 'once')];
    mergedTable.(columnName) = tables{i}.AngleYXBlades;
end
writetable(mergedTable, 'Combined_AngleYXBlades.csv');
combinedTable = readtable('Combined_AngleYXBlades.csv');
flowTime = combinedTable.FlowTime;
forceColumns = setdiff(combinedTable.Properties.VariableNames, {'FlowTime'});
numPlots = length(forceColumns);
figure;
for i = 1:numPlots
    forceData = combinedTable{:, forceColumns{i}};
    subplot(numPlots, 1, i);
    plot(flowTime, forceData);
    title(forceColumns{i});
    xlabel('FlowTime');
    ylabel('AngleYXBlades');
    grid on;
end
sgtitle('AngleYXBlades vs. FlowTime for Each File');
fieldsToExport={'FlowTime','ForceBlade1X','ForceBlade2X','ForceBlade3X','ForceBlade4X','ForceBlade5X','ForceBlade6X'}
for i = 1:numFiles
    tables{i}.ForceBlade1X=tables{i}.ForceBlade1PsX+tables{i}.ForceBlade1SsX;
	tables{i}.ForceBlade2X=tables{i}.ForceBlade2PsX+tables{i}.ForceBlade2SsX;
	tables{i}.ForceBlade3X=tables{i}.ForceBlade3PsX+tables{i}.ForceBlade3SsX;
	tables{i}.ForceBlade4X=tables{i}.ForceBlade4PsX+tables{i}.ForceBlade4SsX;
	tables{i}.ForceBlade5X=tables{i}.ForceBlade5PsX+tables{i}.ForceBlade5SsX;
	tables{i}.ForceBlade6X=tables{i}.ForceBlade6PsX+tables{i}.ForceBlade6SsX;
	filename = sprintf('ForceBladeX of Table%d.csv', i);
	tableToExport = tables{i}(:, fieldsToExport);
    writetable(tableToExport, filename);
	figure;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade1X);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade2X);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade3X);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade4X);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade5X);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade6X);
	hold off;
    title('ForceBladeX of Table ', i);
    xlabel('FlowTime');
    ylabel('ForceBladeX');
end
trigonometric_fit_and_export('ForceBladeX of Table1.csv', 'ForceBladeX of Table1');
fieldsToExport={'FlowTime','ForceBlade1Y','ForceBlade2Y','ForceBlade3Y','ForceBlade4Y','ForceBlade5Y','ForceBlade6Y'}
for i = 1:numFiles
    tables{i}.ForceBlade1Y=tables{i}.ForceBlade1PsY+tables{i}.ForceBlade1SsY;
	tables{i}.ForceBlade2Y=tables{i}.ForceBlade2PsY+tables{i}.ForceBlade2SsY;
	tables{i}.ForceBlade3Y=tables{i}.ForceBlade3PsY+tables{i}.ForceBlade3SsY;
	tables{i}.ForceBlade4Y=tables{i}.ForceBlade4PsY+tables{i}.ForceBlade4SsY;
	tables{i}.ForceBlade5Y=tables{i}.ForceBlade5PsY+tables{i}.ForceBlade5SsY;
	tables{i}.ForceBlade6Y=tables{i}.ForceBlade6PsY+tables{i}.ForceBlade6SsY;
	filename = sprintf('ForceBladeY of Table%d.csv', i);
	tableToExport = tables{i}(:, fieldsToExport);
    writetable(tableToExport, filename);
	figure;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade1Y);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade2Y);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade3Y);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade4Y);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade5Y);
	hold on;
	plot(tables{i}.FlowTime,tables{i}.ForceBlade6Y);
	hold off;
    title('ForceBladeY of Table ', i);
    xlabel('FlowTime');
    ylabel('ForceBladeY');
end
trigonometric_fit_and_export('ForceBladeY of Table1.csv', 'ForceBladeY of Table1');
trigonometric_withfixedb_1stfit_and_export('ForceBladeX of Table1.csv', 'ForceBladeX of Table1');
trigonometric_withfixedb_1stfit_and_export('ForceBladeX of Table2.csv', 'ForceBladeX of Table2');
trigonometric_withfixedb_1stfit_and_export('ForceBladeX of Table3.csv', 'ForceBladeX of Table3');
trigonometric_withfixedb_1stfit_and_export('ForceBladeX of Table4.csv', 'ForceBladeX of Table4');
trigonometric_withfixedb_1stfit_and_export('ForceBladeX of Table5.csv', 'ForceBladeX of Table5');
trigonometric_withfixedb_1stfit_and_export('ForceBladeY of Table1.csv', 'ForceBladeY of Table1');
trigonometric_withfixedb_1stfit_and_export('ForceBladeY of Table2.csv', 'ForceBladeY of Table2');
trigonometric_withfixedb_1stfit_and_export('ForceBladeY of Table3.csv', 'ForceBladeY of Table3');
trigonometric_withfixedb_1stfit_and_export('ForceBladeY of Table4.csv', 'ForceBladeY of Table4');
trigonometric_withfixedb_1stfit_and_export('ForceBladeY of Table5.csv', 'ForceBladeY of Table5');
tableToExport=table(tables{1}.FlowTime,tables{1}.ForceBlade1X...
	,tables{2}.ForceBlade1X,tables{3}.ForceBlade1X,tables{4}.ForceBlade1X,tables{5}.ForceBlade1X,...
	'VariableNames',{'FlowTime','Q08','Q09','Q10','Q11','Q12'});
writetable(tableToExport, 'combined_ForceBlade1X.csv');
disp('Splice completed and output to combined_ForceBlade1X.csv');
figure;
plot(tableToExport.FlowTime,tableToExport.Q08);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q09);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q10);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q11);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q12);
hold off;
trigonometric_withfixedb_fit_and_export('combined_ForceBlade1X.csv', 'combined_ForceBlade1X');	
tableToExport=table(tables{1}.FlowTime,tables{1}.ForceBlade1Y...
	,tables{2}.ForceBlade1Y,tables{3}.ForceBlade1Y,tables{4}.ForceBlade1Y,tables{5}.ForceBlade1Y,...
	'VariableNames',{'FlowTime','Q08','Q09','Q10','Q11','Q12'});
writetable(tableToExport, 'combined_ForceBlade1Y.csv');
disp('Splice completed and output to combined_ForceBlade1Y.csv');
figure;
plot(tableToExport.FlowTime,tableToExport.Q08);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q09);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q10);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q11);
hold on;
plot(tableToExport.FlowTime,tableToExport.Q12);
hold off;
trigonometric_withfixedb_fit_and_export('combined_ForceBlade1Y.csv', 'combined_ForceBlade1Y');
%User-Defined Functions
function output_files = FFT_plot_and_export(input_csv, label,fs)
	if nargin < 3
    fs = 180*2900/60;
	end
	data = readmatrix(input_csv);
	time = data(:, 1);
	num_fields = size(data, 2) - 1;
	fields = data(:, 2:end);
	fft_results_cell = cell(num_fields, 1);
	figure;
	for i = 1:num_fields
    field = fields(:, i);
    N = length(field);
    Y = fft(field);
    P2 = abs(Y / N);
    P1 = (P2(1:floor(N/2)+1));
    P1(2:end-1) = 2*P1(2:end-1);
    f = fs * (0:floor(N/2)) / N;
    fft_results_cell{i} = [f' P1];
    subplot(num_fields, 1, i);
    plot(f, P1);
    title(['Field ', num2str(i), ' FFT']);
    xlabel('Frequency (Hz)');
    ylabel('Magnitude');
	end
	f = fft_results_cell{1}(:, 1);
	num_fields = length(fft_results_cell);
	fft_results_matrix = zeros(length(f), num_fields);
	for i = 1:num_fields
    fft_results_matrix(:, i) = fft_results_cell{i}(:, 2);
	end
	complete_data = [f, fft_results_matrix];
    data_filename = sprintf('FFT_Results_%s.csv', label);
	writematrix(complete_data, data_filename, 'Delimiter', ',');
	disp(['FFT completed: ', data_filename]);
end
function output_files = trigonometric_fit_and_export(input_csv, label)
    data = readmatrix(input_csv);
    time = data(:, 1);
    values = data(:, 2:end);
    numCols = size(values, 2);
    all_params = zeros(numCols, 5);
    all_residuals = zeros(size(values));
    all_fitted_values = zeros(size(values));
    model = @(params, x) params(1) * sin(params(2) * x + params(3)) + params(4);
	options = optimoptions('lsqcurvefit', 'Display', 'off', 'Algorithm', 'levenberg-marquardt', 'MaxIter', 10000, 'TolFun', 1e-6);
    for i = 1:numCols
        y = values(:, i);
		initial_params = [(max(y) - mean(y))/2, 4*pi/(max(time) - min(time)), 0, mean(y)];
        fitted_params = lsqcurvefit(model, initial_params, time, y, [], [], options);
        y_fit = model(fitted_params, time);
        residuals = y - y_fit;
        SS_res = sum(residuals.^2);
        SS_tot = sum((y - mean(y)).^2);
        R_squared = 1 - (SS_res / SS_tot);
        all_params(i, :) = [fitted_params, R_squared];
        all_residuals(:, i) = residuals;
        all_fitted_values(:, i) = y_fit;
    end
    output_data = [time, values, all_fitted_values, all_residuals];
    header = {'FlowTime'};
    for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Original'];
	end
	for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Fitted'];
	end
	for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Residual'];
    end
    output_data_table = array2table(output_data, 'VariableNames', header);
    data_filename = sprintf('output_data_%s.csv', label);
    params_filename = sprintf('fitted_params_%s.csv', label);
    writetable(output_data_table, data_filename);
    params_header = {'a', 'b', 'c', 'd', 'R^2'};
	output_param_table=array2table(all_params, 'VariableNames', params_header);
	NumCols={};
    for i = 1:numCols
	NumCols{i}=[i];
    end
	output_param_table.NumCol=NumCols';
	output_param_table=output_param_table(:,{'NumCol','a', 'b', 'c', 'd', 'R^2'});
	writetable(output_param_table, params_filename);
    output_files = struct('data_file', data_filename, 'params_file', params_filename);
end
function output_files = trigonometric_withfixedb_1stfit_and_export(input_csv, label)
    data = readmatrix(input_csv);
    time = data(:, 1);
    values = data(:, 2:end);
    numCols = size(values, 2);
    all_params = zeros(numCols, 5);
    all_residuals = zeros(size(values));
    all_fitted_values = zeros(size(values));
	T=60/2900;
	b=2*pi/T;
    model = @(params, x) params(1) * sin(b * x + params(2)) + params(3);
	options = optimoptions('lsqcurvefit', 'Display', 'off', 'Algorithm', 'levenberg-marquardt', 'MaxIter', 10000, 'TolFun', 1e-6);
	i = 1;
    y = values(:, i);
	initial_params = [(max(y) - mean(y))/2, 0, mean(y)];
    fitted_params = lsqcurvefit(model, initial_params, time, y, [], [], options);
    y_fit = model(fitted_params, time);
    residuals = y - y_fit;
    SS_res = sum(residuals.^2);
    SS_tot = sum((y - mean(y)).^2);
    R_squared = 1 - (SS_res / SS_tot);
	fitted_params_srorage=[fitted_params(1), b, fitted_params(2:end)];
    all_params(i, :) = [fitted_params_srorage, R_squared];
    all_residuals(:, i) = residuals;
    all_fitted_values(:, i) = y_fit;
    for i = 2:numCols
        y = values(:, i);
        fitted_params(2) = fitted_params(2)-pi/3;
		if fitted_params(2)<-2*pi
			fitted_params(2) = fitted_params(2)+2*pi;
		end
        y_fit = model(fitted_params, time);
        residuals = y - y_fit;
        SS_res = sum(residuals.^2);
        SS_tot = sum((y - mean(y)).^2);
        R_squared = 1 - (SS_res / SS_tot);
		fitted_params_srorage=[fitted_params(1), b, fitted_params(2:end)];
        all_params(i, :) = [fitted_params_srorage, R_squared];
        all_residuals(:, i) = residuals;
        all_fitted_values(:, i) = y_fit;
    end
    output_data = [time, values, all_fitted_values, all_residuals];
    header = {'FlowTime'};
    for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Original'];
	end
	for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Fitted'];
	end
	for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Residual'];
    end
    output_data_table = array2table(output_data, 'VariableNames', header);
    data_filename = sprintf('1stoutput_data_withfixedb_%s.csv', label);
    params_filename = sprintf('1stfitted_params_withfixedb_%s.csv', label);
    writetable(output_data_table, data_filename);
    params_header = {'a', 'b', 'c', 'd', 'R^2'};
	output_param_table=array2table(all_params, 'VariableNames', params_header);
	NumCols={};
    for i = 1:numCols
	NumCols{i}=[i];
    end
	output_param_table.NumCol=NumCols';
	output_param_table=output_param_table(:,{'NumCol','a', 'b', 'c', 'd', 'R^2'});
	writetable(output_param_table, params_filename);
    output_files = struct('data_file', data_filename, 'params_file', params_filename);
end
function output_files = trigonometric_withfixedb_fit_and_export(input_csv, label)
    data = readmatrix(input_csv);
    time = data(:, 1);
    values = data(:, 2:end);
    numCols = size(values, 2);
    all_params = zeros(numCols, 5);
    all_residuals = zeros(size(values));
    all_fitted_values = zeros(size(values));
	T=60/2900;
	b=2*pi/T;
    model = @(params, x) params(1) * sin(b * x + params(2)) + params(3);
	options = optimoptions('lsqcurvefit', 'Display', 'off', 'Algorithm', 'levenberg-marquardt', 'MaxIter', 10000, 'TolFun', 1e-6);
    for i = 1:numCols
        y = values(:, i);
		initial_params = [(max(y) - mean(y))/2,  0, mean(y)];
        fitted_params = lsqcurvefit(model, initial_params, time, y, [], [], options);
        y_fit = model(fitted_params, time);
        residuals = y - y_fit;
        SS_res = sum(residuals.^2);
        SS_tot = sum((y - mean(y)).^2);
        R_squared = 1 - (SS_res / SS_tot);
        fitted_params=[fitted_params(1), b, fitted_params(2:end)];
        all_params(i, :) = [fitted_params, R_squared];
        all_residuals(:, i) = residuals;
        all_fitted_values(:, i) = y_fit;
    end
    output_data = [time, values, all_fitted_values, all_residuals];
    header = {'FlowTime'};
    for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Original'];
	end
	for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Fitted'];
	end
	for i = 1:numCols
        header{end+1} = ['Col_', num2str(i), '_Residual'];
    end
    output_data_table = array2table(output_data, 'VariableNames', header);
    data_filename = sprintf('output_data_withfixedb_%s.csv', label);
    params_filename = sprintf('fitted_params_withfixedb_%s.csv', label);
    writetable(output_data_table, data_filename);
    params_header = {'a', 'b', 'c', 'd', 'R^2'};
	output_param_table=array2table(all_params, 'VariableNames', params_header);
	NumCols={};
    for i = 1:numCols
	NumCols{i}=[i];
    end
	output_param_table.NumCol=NumCols';
	output_param_table=output_param_table(:,{'NumCol','a', 'b', 'c', 'd', 'R^2'});
	writetable(output_param_table, params_filename);
    output_files = struct('data_file', data_filename, 'params_file', params_filename);
end	